new_blog/mysite/blog/urls.py
from django.urls import path
from .views import PostListView, PostDetailView
from . import views

app_name = 'blog'

urlpatterns = [
    # path('',views.post_list, name='home'),
    path('',PostListView.as_view(), name='home'),
    # path('<int:pk>/<slug:slug>/', views.post_detail, name='detail'),
    path('<int:pk>/<slug:slug>/', PostDetailView.as_view(), name = 'detail'),
    path('category/<slug:slug>/',views.post_by_category,name='post_by_category'),
    path('tag/<slug:slug>/', views.post_by_tag, name = 'post_by_tag'),
    path('blog/',views.test_redirect, name = 'test_redirect'),
    path('feedback/',views.feedback, name = 'feedback'),

]

new_blog/mysite/cadmin/urls.py
from django.urls import path
from . import views
from django.contrib.auth import views as auth_views
from .views import PostCreateView, PostUpdateView, PostDeleteView


app_name = 'cadmin'

urlpatterns = [
    path('activate/account/', views.activate_account, name = 'activate'),
    path('register/', views.register, name = 'register'),
    path('login/', auth_views.LoginView.as_view(template_name = 'cadmin/login.html'), name = 'login'),
    path('logout/', auth_views.LogoutView.as_view(template_name = 'cadmin/logout.html'), name = 'logout'),
    path('profile/',views.profile,name= 'profile'),
    # path('post/add/',views.post_add,name= 'post_add'),
    path('post/add/', PostCreateView.as_view(),name = 'post-create'),
    # path('post/update/<int:pk>/', views.post_update, name = 'post_update'),
    path('post/update/<int:pk>/', PostUpdateView.as_view(), name = 'post-update'),
    path('post/delete/<int:pk>/', PostDeleteView.as_view(), name = 'post-delete')



]

new_blog/mysite/blog/models.py
from django.db import models
from PIL import Image
# Create your models here.
from django.db import models
from django.template.defaultfilters import slugify
from django.urls import reverse
from django.contrib.auth.models import User
# Create your models here
class Author(models.Model):

    user = models.OneToOneField(User, null=True, blank=True, on_delete=models.CASCADE)
    pp = models.ImageField(default = 'default/default.jpg', upload_to = 'profile_pics',verbose_name='Profile Picture')
    # additional fields
    activation_key = models.CharField(max_length=255, default=1)
    email_validated = models.BooleanField(default=False)



    def __str__(self,*args, **kwargs):
        return self.user.username

    def save(self):
        super().save()
        img = Image.open(self.pp.path)

        if img.height > 300 or img.width > 300:
            output_size = (300,300)
            img.thumbnail(output_size)
            img.save(self.pp.path)
            
        


class Category(models.Model):
    name = models.CharField(max_length=100, unique=True)
    slug = models.SlugField(help_text='Slug will be generated automatically', unique=True)
    author = models.ForeignKey(Author, null=True, blank=True, on_delete = models.CASCADE)

    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        super(Category,self).save(*args, **kwargs)

    def __str__(self):
        return self.name
    class Meta:
        verbose_name_plural = 'Categories'
    
    def get_absolute_url(self):

        return reverse('blog:post_by_category', args = [self.slug])


class Tag(models.Model):
    name = models.CharField(max_length=100, unique=True, verbose_name='Tags')
    slug = models.SlugField(help_text='Slug will be generated automatically', unique=True)
    author = models.ForeignKey(Author, null=True, blank=True, on_delete = models.CASCADE)

    def __str__(self):

        return self.name
    def save(self, *args, **kwargs):
        self.slug = slugify(self.name)
        super(Tag,self).save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('blog:post_by_tag', args = [self.slug])


class Post(models.Model):
    title = models.CharField(max_length=200)
    slug = models.SlugField(unique=True, help_text='Slug will be generated automatically')
    content = models.TextField()
    pub_date = models.DateTimeField(auto_now_add=True)
    author = models.ForeignKey(Author, on_delete=models.CASCADE)
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    tags = models.ManyToManyField(Tag)

    def __str__(self):
        
        return self.title

    def save(self, *args, **kwargs):
        self.slug = slugify(self.title)
        super(Post,self).save(*args, **kwargs)
    
    def get_absolute_url(self):
        return reverse('blog:detail', args=[self.id, self.slug])

class Feedback(models.Model):
    name = models.CharField(max_length=200, help_text="Name of the sender")
    email = models.EmailField(max_length=200)
    subject = models.CharField(max_length=150)
    message = models.TextField()
    date = models.DateTimeField(auto_now_add=True)

    class Meta:
        verbose_name_plural = "Feedback"

    def __str__(self):
        return self.name+ "-" + self.email

    def get_absolut_url(self):
        return reverse('blog:feedback')

new_blog/mysite/blog/forms.py
from django import forms
from django.core.exceptions import ValidationError
from .models import *
from django.template.defaultfilters import slugify

# class AuthorForm(forms.Form):
#     name = forms.CharField(max_length=50)
#     email = forms.EmailField()
#     active = forms.BooleanField(required=False)
#     # custom validators
#     def clean_name(self):
#         name = self.cleaned_data['name']
#         nae_l = name.lower()
#         if name_l == 'admin' or name_l == 'author':
#             raise ValidationError('Name cannot be admin or author')
#         return name_l
#     def clean_email(self):
#         email = self.cleaned_data['email']
#         return email.lower()

# class AuthorForm(forms.ModelForm):
#     class Meta:
#         model = Author
#         fields = ['name', 'email', 'active']
#     def clean_name(self):
#         name = self.cleaned_data['name']
#         nae_l = name.lower()
#         if name_l == 'admin' or name_l == 'author':
#             raise ValidationError('Name cannot be admin or author')
#         return name_l
    
#     def clean_email(self):
#         email = self.cleaned_data['email']
#         return email.lower()

class TagForm(forms.ModelForm):
    class Meta:
        model = Tag
        fields = ['name']

    def clean_name(self):
        name = self.cleaned_data['name'].lower()
        if name == 'tag' or name == 'add' or name == 'update':
            raise ValidationError('Tag cannot be {}'.format(name))
        return self.cleaned_data['name']

    def clean(self):

        cleaned_data = super(TagForm,self).clean()
        name = cleaned_data.get('name')

        if name:
            cleaned_data['slug'] = slugify(name)
        return cleaned_data

class CategoryForm(forms.ModelForm):
    class Meta:
        model = Category
        fields = ['name']
    
    def clean_name(self):
        name = self.cleaned_data['name'].lower()
        if name == 'tag' or name == 'add' or name == 'update':
            raise ValidationError('Tag cannot be {}'.format(name))
        return self.cleaned_data['name']

    def clean(self):

        
        cleaned_data = super(CategoryForm,self).clean()
        name = cleaned_data.get('name')

        if name:
            cleaned_data['slug'] = slugify(name)
        return cleaned_data

class PostForm(forms.ModelForm):
    class Meta:
        model = Post
        fields = ['title', 'content', 'category', 'tags']
    
    
  
    def clean_name(self):
        name = self.cleaned_data['title'].lower()
        if name == 'tag' or name == 'add' or name == 'update':
            raise ValidationError('Tag cannot be {}'.format(name))
        return self.cleaned_data['name']

    def clean(self):
        cleaned_data = super(PostForm,self).clean()
        title = cleaned_data.get('title')

        if title:
            cleaned_data['slug'] = slugify(title)
        return cleaned_data

class FeedbackForm(forms.ModelForm):
    class Meta:
        model = Feedback
        fields = '__all__'

new_blog/mysite/blog/views.py
from django.shortcuts import render
from django.views.generic import ListView, DetailView
from django.shortcuts import render, get_object_or_404, get_list_or_404, redirect
from django.http import HttpResponse, HttpResponseRedirect
from .models import Post, Category, Tag
from . forms import FeedbackForm
from django.contrib import messages
from django.core.paginator import Paginator


# def post_list(request):
#     post = Post.objects.all().order_by('-pub_date')
#     # pagintator = Paginator(post, 3)
#     return render(request, 'blog/index.html',{'posts':post})

##LisView for post list
class PostListView(ListView):
    model = Post
    template_name = 'blog/index.html'
    context_object_name = 'posts'
    ordering = ['-pub_date']

# def post_detail(request, pk, slug):
#     post = get_object_or_404(Post, pk=pk)
#     # post = Post.objects.get(pk=pk)
#     return render(request, 'blog/post_detail.html',{'post':post})

#PostDetailView
class PostDetailView(DetailView):
    model = Post
    context_object_name = 'post'

def post_by_category(request, slug):
    category = get_object_or_404(Category, slug = slug)
    # category = Category.objects.get(slug = slug)
    post = get_list_or_404(Post.objects.order_by('-pub_date'), category__slug = slug)
    # post = Post.objects.filter(category__slug = slug)

    context = {
        'category': category,
        'posts': post
    }

    return render(request, 'blog/post_by_category.html', context)

def post_by_tag(request, slug):
    tag = get_object_or_404(Tag, slug = slug)
    # tag = Tag.objects.get(slug = slug)
    post = get_list_or_404(Post.objects.order_by('-pub_date'), tags__slug = slug)
    # post = Post.objects.filter(tags__slug = slug)

    context = {
        'tag':tag,
        'posts': post
    }

    return render(request, 'blog/post_by_tag.html', context)

def test_redirect(request):
    return HttpResponseRedirect('https://www.google.com')

def feedback(request):
    if request.method == 'POST':
        f = FeedbackForm(request.POST)
        if f.is_valid():
            f.save()
            message = messages.add_message(request, messages.INFO, 'Feedback Submitted')
            
            return redirect('blog:feedback')

    else:
        f = FeedbackForm()
    return render(request, 'blog/feedback.html', {'form':f})

new_blog/mysite/templates/blog/feedback.html
{%extends 'base.html'%}

{% block content %}
    {% if messages %}
        <ul class = 'messages'>
            {% for message in messages %}
                <li {% if message.tags%} class="{{ message.tags }}" {% endif %}>{{ message}}</li>
            {% endfor %}    
        </ul>
    {% endif %}

    <h3>Submit Your feedback </h3>
    <form action="" method='POST'>
        {% csrf_token %}
        {{form.as_p }}
            <tr>
                <td></td>
                <td><input type="submit" value="Submit"></td>
            </tr>
    </form>

{% endblock %}

new_blog/mysite/templates/blog/index.html
{% extends 'base.html' %}

{% block content %}
    {% if messages %}
        {% for message in messages %}
            <div class="alert-{{message.tags}}">
                {{message}}
            </div>
        {% endfor %}
    {% endif %}
    <h1>Welcome to Django Blog</h1>

    {% for post in posts %}           
        {% include 'blog/post_info.html' %}
          
    {% empty %}
        <p>There are no posts here </p>    

    {% endfor %}
{% endblock %}

new_blog/mysite/templates/blog/post_by_category.html
{% extends 'base.html'%}
{% block title %}
    {{ category|title }} - {{ block.super }}
{% endblock %}

{% block content %}
    <h4>All posts under category: {{ category.name|capfirst }}</h4>

    {% for post in posts %}

        {% include 'blog/post_info.html' %}
 
    {% empty %}
        No Post in this Category
    {% endfor %}
{% endblock%}

new_blog/mysite/templates/blog/post_by_tag.html
{% extends 'base.html'%}

{% block title %}
    {{ tag|title }} - {{ block.super }}
{% endblock %}

{% block content %}
    <h4>All posts under tag: {{ tag.name|capfirst }}</h4>

    {% for post in posts %}

        {% include 'blog/post_info.html' %}
      
    {% empty %}
        No Post are tagged with {{ tag }}
    {% endfor %}
{% endblock%}

new_blog/mysite/templates/blog/post_detail.html
{% extends 'base.html' %}

{% block title %}
    {{ post.title }} - {{ block.super }}
{% endblock %}
{% block content %}
<div class="row">
    <div class="col s12 m6">
    <div class="card light-grey darken-1">
        <div>
            <ul>
                 <li><div class="user-view">
                     <img class="circle article-img" width="50" src="{{ post.author.user.author.pp.url }}">
                     <span class="">@{{ post.author.user.username}}</span>
                     {% if post.author.user == request.user %}
                <a href="{%url 'cadmin:post-update' post.id%}" class="btn btn-secondary">Update</a>
                <a href="{%url 'cadmin:post-delete' post.id%}" class="btn btn-secondary">Delete</a>
            {%endif%}
                   </div></li>
       </div>
        
        <div class="card-content">
            <span class="card-title">
                {{ post.title|capfirst }}
            </span>
            <p>{{ post.content}}</p>
       
            </div>
       
       <div class="card-action">
            <span>Date: {{ post.pub_date.date}} </span> |
            <span>Category: <a href="{{ post.category.get_absolute_url }}">{{post.category.name}}</a></span> |    
            <span>Tags:
            {% for tag in post.tags.all %}
                 <a href="{{ tag.get_absolute_url }}">{{ tag.name }}</a>
            {% empty %}          
                 None
            {%endfor%}
            

       </span>
       </div>
    </div>
    </div>
</div>





{% endblock %}

new_blog/mysite/templates/blog/post_info.html
<div class="row">
     <div class="col s12 m6">
     <div class="card light-grey darken-1">
          <div>
               <ul>
                    <li><div class="user-view">
                        <img class="circle" width="50" src="{{ post.author.user.author.pp.url }}">
                        <span class="">{{ post.author.user.username}}</span>
                        
                      </div></li>
          </div>

         <div class="card-content ">
         <span class="card-title"><a href="{{ post.get_absolute_url }}">
             {{ post.title|capfirst }}
         </a></span>
         <p>{{ post.content|truncatewords:"5"}}</p>
         </div>
         <div class="card-action">
          
          <span>Date: {{ post.pub_date.date}} </span> |
          <span>Category: <a href="{{ post.category.get_absolute_url }}">{{post.category.name}}</a></span> |    
          <span>Tags:
          {% for tag in post.tags.all %}
               <a href="{{ tag.get_absolute_url }}">{{ tag.name }}</a>
          {% empty %}          
               None
          {%endfor%}
     </span>
     </div>
     
     </div>
     </div>
 </div>